/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.grid;

import com.jiuqi.grid.CellDataProcessorIntf;
import com.jiuqi.grid.CellDataProperty;
import com.jiuqi.grid.CellDataPropertyIntf;
import com.jiuqi.grid.GridCell;
import com.jiuqi.grid.TextCellPropertyIntf;

public class TextCellProperty
implements TextCellPropertyIntf,
CellDataProcessorIntf {
    protected CellDataPropertyIntf cellDataProperty;

    public TextCellProperty(GridCell cell) {
        this(new CellDataProperty(cell));
    }

    public TextCellProperty(CellDataPropertyIntf dataProperty) {
        this.cellDataProperty = dataProperty;
    }

    public CellDataPropertyIntf getCellDataProperty() {
        return this.cellDataProperty;
    }

    public boolean getMultiLine() {
        return (this.cellDataProperty.getDataFlag() & 1) != 0;
    }

    public void setMultiLine(boolean value) {
        if (value) {
            this.cellDataProperty.setDataFlag((byte)(this.cellDataProperty.getDataFlag() | 1));
        } else {
            this.cellDataProperty.setDataFlag((byte)(this.cellDataProperty.getDataFlag() & 0xFFFFFFFE));
        }
    }

    public boolean getAllowMultiLine() {
        return (this.cellDataProperty.getDataFlag() & 2) != 0;
    }

    public void setAllowMultiLine(boolean value) {
        if (value) {
            this.cellDataProperty.setDataFlag((byte)(this.cellDataProperty.getDataFlag() | 2));
        } else {
            this.cellDataProperty.setDataFlag((byte)(this.cellDataProperty.getDataFlag() & 0xFFFFFFFD));
        }
    }

    public int getCharCase() {
        return this.cellDataProperty.getDataFlag() >> 2;
    }

    public void setCharCase(int value) {
        if (value < 0 || value >= 3) {
            throw new IllegalArgumentException("错误设置了文本大小写情况,只能在0-2之间！");
        }
        int data = (value & 3) << 2;
        this.cellDataProperty.setDataFlag((byte)(this.cellDataProperty.getDataFlag() & 0xFFFFFFF3 | data));
    }

    public int getMaxLength() {
        return this.cellDataProperty.getDataProperty();
    }

    public void setMaxLength(int value) {
        if (value < 0) {
            throw new IllegalArgumentException("不能设置文本的最大长度为负数！");
        }
        this.cellDataProperty.setDataProPerty((short)value);
    }

    public String getEditText(String storeText) {
        return storeText;
    }

    public String getShowText(String storeText) {
        return storeText;
    }

    public String parseEditText(String editText) {
        if (editText != null) {
            if (editText == "") {
                return "";
            }
            String storeText = null;
            int charCase = this.getCharCase();
            switch (charCase) {
                case 0: {
                    storeText = editText;
                    break;
                }
                case 2: {
                    storeText = editText.toLowerCase();
                    break;
                }
                case 1: {
                    storeText = editText.toUpperCase();
                    break;
                }
                default: {
                    storeText = editText;
                }
            }
            int textLength = storeText.length();
            int maxLength = this.getMaxLength();
            if (maxLength != 0 && textLength > maxLength) {
                storeText = storeText.substring(0, maxLength);
            }
            return storeText;
        }
        throw new IllegalArgumentException("不能解析指向null的字符串！");
    }

    public String parseShowText(String showText) {
        return this.parseEditText(showText);
    }
}

